#ifndef FRAMENAV_H
#define FRAMENAV_H

#include <QDockWidget>
#include <QPushButton>
#include <QSpinBox>
#include <QSlider>


class FrameNav : public QDockWidget
{
    Q_OBJECT
public:

    explicit FrameNav(QWidget *parent, Qt::WindowFlags flags);
    explicit FrameNav(const QString & title, QWidget * parent = 0, Qt::WindowFlags flags = 0);


    // components

    QPushButton* buttonFirst;
    QPushButton* buttonPrev;
    QPushButton* buttonNext;
    QPushButton* buttonLast;
    QPushButton* buttonPlay;

    QSpinBox* spinBox;

    QSlider* slider;

    void setButtonPlaying();
    void setButtonAllActive();

    // event slots
public slots:
    void onButtonFirstClicked();
    void onButtonPrevClicked();
    void onButtonNextClicked();
    void onButtonLastClicked();
    void onButtonPlayClicked();
    void onSpinBoxEditingFinished();
    void onSliderValueChanged(int v);

    void connectToState();
    void filterStateChange(int f);

    void reload();

private:
     volatile bool stopPlay = true;
};

#endif // FRAMENAV_H
