#ifndef FUNCTIONS_H
#define FUNCTIONS_H

#include <QPolygonF>
#include "opencv2/core.hpp"
#include "Geometry"

namespace Functions {

    //geomoetry functions
    bool isCounterClockwise(QPolygonF poly);
    qreal triangleAngleCFromSidesABC(qreal a, qreal b, qreal c);
    qreal degAngleCounterClockwise(QPointF from, QPointF to);
    qreal vecLength(QPointF p);
    qreal vecLengthSquared(QPointF p);
    qreal distance(QPointF p1, QPointF p2);
    qreal dot(QPointF p1, QPointF p2);
    qreal distToLine(QPointF p, QPointF l1, QPointF l2);
    qreal distToLineSegment(QPointF p, QPointF l1, QPointF l2);
    QPolygonF transformPolygonAffine(QPolygonF polygon, Eigen::Affine2d affineTransform);

    //cv functions
    std::vector<cv::Point> getOpenCvPolygon(QPolygonF polygon);
    QPolygonF getQPolygonF(std::vector<cv::Point> polygon);
}

#endif // FUNCTIONS_H
