#include <QApplication>
#include <QtGlobal>
#include "globalobjects.h"
#include "core/mainwindow.h"
#include "core/datastate.h"

// set extern in globalobjects, declare here
MainWindow* g_mainWindow;
DataState* g_state;

int main(int argc, char *argv[])
{
    QApplication a(argc, argv);

    #ifdef Q_OS_MAC
    a.setWindowIcon(QIcon(":icons/mainicon.icns"));
    #else
    a.setWindowIcon(QIcon(":icons/mainicon.ico"));
    #endif

    // set global pointer to these local references,
    // so the objects will be deleted at the end of the main-function
    g_state = new DataState();

    // NOTICE: the global reference to MainWindow cannot be accessed in constructors
    MainWindow w;
    g_mainWindow = &w;
    w.show();

    int result = a.exec();

    delete g_state;
    return result;

}
